Index: kern/kern_clock.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_clock.c,v
retrieving revision 1.14
diff -u -r1.14 kern_clock.c
--- kern/kern_clock.c	7 Jan 2004 20:21:46 -0000	1.14
+++ kern/kern_clock.c	27 Jan 2004 23:01:05 -0000
@@ -1,4 +1,5 @@
 /*-
+ * Copyright (c) 2004, Matthew Dillon <dillon@backplane.com>
  * Copyright (c) 1997, 1998 Poul-Henning Kamp <phk@FreeBSD.org>
  * Copyright (c) 1982, 1986, 1991, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -74,23 +75,9 @@
 extern void hardclock_device_poll(void);
 #endif /* DEVICE_POLLING */
 
-/*
- * Number of timecounters used to implement stable storage
- */
-#ifndef NTIMECOUNTER
-#define NTIMECOUNTER	5
-#endif
-
-static MALLOC_DEFINE(M_TIMECOUNTER, "timecounter", 
-	"Timecounter stable storage");
-
 static void initclocks (void *dummy);
 SYSINIT(clocks, SI_SUB_CLOCKS, SI_ORDER_FIRST, initclocks, NULL)
 
-static void tco_forward (int force);
-static void tco_setscales (struct timecounter *tc);
-static __inline unsigned tco_delta (struct timecounter *tc);
-
 /*
  * Some of these don't belong here, but it's easiest to concentrate them.
  * Note that cp_time[] counts in microseconds, but most userland programs
@@ -106,165 +93,372 @@
 long tk_nout;
 long tk_rawcc;
 
-time_t time_second;
+/*
+ * boottime is used to calculate the 'real' uptime.  Do not confuse this with
+ * microuptime().  microtime() is not drift compensated.  The real uptime
+ * with compensation is nanotime() - bootime.
+ *
+ * basetime is used to calculate the compensated real time of day.  Chunky
+ * changes to the time, aka settimeofday(), are made by modifying basetime.
+ *
+ * The gd_time_seconds and gd_cpuclock_base fields remain fairly monotonic.
+ * Slight adjustments to gd_cpuclock_base are made to phase-lock it to
+ * the real time.
+ */
+struct timespec boottime;	/* boot time (realtime) for reference only */
+struct timespec basetime;	/* base time adjusts uptime -> realtime */
+time_t time_second;		/* read-only 'passive' uptime in seconds */
 
-struct	timeval boottime;
 SYSCTL_STRUCT(_kern, KERN_BOOTTIME, boottime, CTLFLAG_RD,
     &boottime, timeval, "System boottime");
+SYSCTL_STRUCT(_kern, OID_AUTO, basetime, CTLFLAG_RD,
+    &basetime, timeval, "System basetime");
 
-/*
- * Which update policy to use.
- *   0 - every tick, bad hardware may fail with "calcru negative..."
- *   1 - more resistent to the above hardware, but less efficient.
- */
-static int tco_method;
+static void hardclock(systimer_t info, struct intrframe *frame);
+static void statclock(systimer_t info, struct intrframe *frame);
+static void schedclock(systimer_t info, struct intrframe *frame);
+
+int	ticks;			/* system master ticks at hz */
+int64_t	nsec_adj;		/* ntpd per-tick adjustment in nsec << 32 */
+int64_t	nsec_acc;		/* accumulator */
 
 /*
- * Implement a dummy timecounter which we can use until we get a real one
- * in the air.  This allows the console and other early stuff to use
- * timeservices.
+ * Finish initializing clock frequencies and start all clocks running.
  */
-
-static unsigned 
-dummy_get_timecount(struct timecounter *tc)
+/* ARGSUSED*/
+static void
+initclocks(void *dummy)
 {
-	static unsigned now;
-	return (++now);
+	cpu_initclocks();
+#ifdef DEVICE_POLLING
+	init_device_poll();
+#endif
+	/*psratio = profhz / stathz;*/
+	initclocks_pcpu();
 }
 
-static struct timecounter dummy_timecounter = {
-	dummy_get_timecount,
-	0,
-	~0u,
-	1000000,
-	"dummy"
-};
+/*
+ * Called on a per-cpu basis
+ */
+void
+initclocks_pcpu(void)
+{
+	struct globaldata *gd = mycpu;
 
-struct timecounter *timecounter = &dummy_timecounter;
+	crit_enter();
+	if (gd->gd_cpuid == 0) {
+	    gd->gd_time_seconds = 1;
+	    gd->gd_cpuclock_base = cputimer_count();
+	} else {
+	    /* XXX */
+	    gd->gd_time_seconds = globaldata_find(0)->gd_time_seconds;
+	    gd->gd_cpuclock_base = globaldata_find(0)->gd_cpuclock_base;
+	}
+	systimer_init_periodic(&gd->gd_hardclock, hardclock, NULL, hz);
+	systimer_init_periodic(&gd->gd_statclock, statclock, NULL, stathz);
+	/* XXX correct the frequency for scheduler / estcpu tests */
+	systimer_init_periodic(&gd->gd_schedclock, schedclock, NULL, 10); 
+	crit_exit();
+}
 
 /*
- * Clock handling routines.
- *
- * This code is written to operate with two timers that run independently of
- * each other.
- *
- * The main timer, running hz times per second, is used to trigger interval
- * timers, timeouts and rescheduling as needed.
- *
- * The second timer handles kernel and user profiling,
- * and does resource use estimation.  If the second timer is programmable,
- * it is randomized to avoid aliasing between the two clocks.  For example,
- * the randomization prevents an adversary from always giving up the cpu
- * just before its quantum expires.  Otherwise, it would never accumulate
- * cpu ticks.  The mean frequency of the second timer is stathz.
- *
- * If no second timer exists, stathz will be zero; in this case we drive
- * profiling and statistics off the main clock.  This WILL NOT be accurate;
- * do not do it unless absolutely necessary.
- *
- * The statistics clock may (or may not) be run at a higher rate while
- * profiling.  This profile clock runs at profhz.  We require that profhz
- * be an integral multiple of stathz.
- *
- * If the statistics clock is running fast, it must be divided by the ratio
- * profhz/stathz for statistics.  (For profiling, every tick counts.)
- *
- * Time-of-day is maintained using a "timecounter", which may or may
- * not be related to the hardware generating the above mentioned
- * interrupts.
+ * This sets the current real time of day.  Timespecs are in seconds and
+ * nanoseconds.  We do not mess with gd_time_seconds and gd_cpuclock_base,
+ * instead we adjust basetime so basetime + gd_* results in the current
+ * time of day.  This way the gd_* fields are guarenteed to represent
+ * a monotonically increasing 'uptime' value.
  */
+void
+set_timeofday(struct timespec *ts)
+{
+	struct timespec ts2;
 
-int	stathz;
-int	profhz;
-static int profprocs;
-int	ticks;
-static int psticks;			/* profiler ticks */
-static int psdiv;			/* prof / stat divider */
-int	psratio;			/* ratio: prof * 100 / stat */
-
+	/*
+	 * XXX SMP / non-atomic basetime updates
+	 */
+	crit_enter();
+	nanouptime(&ts2);
+	basetime.tv_sec = ts->tv_sec - ts2.tv_sec;
+	basetime.tv_nsec = ts->tv_nsec - ts2.tv_nsec;
+	if (basetime.tv_nsec < 0) {
+	    basetime.tv_nsec += 1000000000;
+	    --basetime.tv_sec;
+	}
+	if (boottime.tv_sec == 0)
+		boottime = basetime;
+	timedelta = 0;
+	crit_exit();
+}
+	
 /*
- * Initialize clock frequencies and start both clocks running.
+ * Each cpu has its own hardclock, but we only increments ticks and softticks
+ * on cpu #0.
+ *
+ * NOTE! systimer! the MP lock might not be held here.  We can only safely
+ * manipulate objects owned by the current cpu.
  */
-/* ARGSUSED*/
 static void
-initclocks(dummy)
-	void *dummy;
+hardclock(systimer_t info, struct intrframe *frame)
 {
-	int i;
+	sysclock_t cputicks;
+	struct proc *p;
+	struct pstats *pstats;
+	struct globaldata *gd = mycpu;
 
 	/*
-	 * Set divisors to 1 (normal case) and let the machine-specific
-	 * code do its bit.
+	 * Realtime updates are per-cpu.  Note that timer corrections as
+	 * returned by microtime() and friends make an additional adjustment
+	 * using a system-wise 'basetime', but the running time is always
+	 * taken from the per-cpu globaldata area.  Since the same clock
+	 * is distributing (XXX SMP) to all cpus, the per-cpu timebases
+	 * stay in synch.
+	 *
+	 * Note that we never allow info->time (aka gd->gd_hardclock.time)
+	 * to reverse index gd_cpuclock_base.
 	 */
-	psdiv = 1;
-	cpu_initclocks();
-
-#ifdef DEVICE_POLLING
-	init_device_poll();
-#endif
+	cputicks = info->time - gd->gd_cpuclock_base;
+	if (cputicks > cputimer_freq) {
+		++gd->gd_time_seconds;
+		gd->gd_cpuclock_base += cputimer_freq;
+	}
 
 	/*
-	 * Compute profhz/stathz, and fix profhz if needed.
+	 * The system-wide ticks and softticks are only updated by cpu #0.
+	 * Callwheel actions are also (at the moment) only handled by cpu #0.
+	 * Finally, we also do NTP related timedelta/tickdelta adjustments
+	 * by adjusting basetime.
 	 */
-	i = stathz ? stathz : hz;
-	if (profhz == 0)
-		profhz = i;
-	psratio = profhz / i;
-}
+	if (gd->gd_cpuid == 0) {
+	    struct timespec nts;
+	    int leap;
 
-/*
- * The real-time timer, interrupting hz times per second.  This is implemented
- * as a FAST interrupt so it is in the context of the thread it interrupted,
- * and not in an interrupt thread.  YYY needs help.
- */
-void
-hardclock(frame)
-	struct clockframe *frame;
-{
-	struct proc *p;
+	    ++ticks;
 
-	p = curproc;
-	if (p) {
-		struct pstats *pstats;
+#ifdef DEVICE_POLLING
+	    hardclock_device_poll();	/* mpsafe, short and quick */
+#endif /* DEVICE_POLLING */
 
-		/*
-		 * Run current process's virtual and profile time, as needed.
-		 */
+	    if (TAILQ_FIRST(&callwheel[ticks & callwheelmask]) != NULL) {
+		setsoftclock();
+	    } else if (softticks + 1 == ticks) {
+		++softticks;
+	    }
+
+#if 0
+	    if (tco->tc_poll_pps) 
+		tco->tc_poll_pps(tco);
+#endif
+	    /*
+	     * Apply adjtime corrections.  At the moment only do this if 
+	     * we can get the MP lock to interlock with adjtime's modification
+	     * of these variables.  Note that basetime adjustments are not
+	     * MP safe either XXX.
+	     */
+	    if (timedelta != 0 && try_mplock()) {
+		basetime.tv_nsec += tickdelta * 1000;
+		if (basetime.tv_nsec >= 1000000000) {
+		    basetime.tv_nsec -= 1000000000;
+		    ++basetime.tv_sec;
+		} else if (basetime.tv_nsec < 0) {
+		    basetime.tv_nsec += 1000000000;
+		    --basetime.tv_sec;
+		}
+		timedelta -= tickdelta;
+		rel_mplock();
+	    }
+
+	    /*
+	     * Apply per-tick compensation.  ticks_adj adjusts for both
+	     * offset and frequency, and could be negative.
+	     */
+	    if (nsec_adj != 0 && try_mplock()) {
+		nsec_acc += nsec_adj;
+		if (nsec_acc >= 0x100000000LL) {
+		    basetime.tv_nsec += nsec_acc >> 32;
+		    nsec_acc = (nsec_acc & 0xFFFFFFFFLL);
+		} else if (nsec_acc <= -0x100000000LL) {
+		    basetime.tv_nsec -= -nsec_acc >> 32;
+		    nsec_acc = -(-nsec_acc & 0xFFFFFFFFLL);
+		}
+		if (basetime.tv_nsec >= 1000000000) {
+		    basetime.tv_nsec -= 1000000000;
+		    ++basetime.tv_sec;
+		} else if (basetime.tv_nsec < 0) {
+		    basetime.tv_nsec += 1000000000;
+		    --basetime.tv_sec;
+		}
+		rel_mplock();
+	    }
+
+	    /*
+	     * If the realtime-adjusted seconds hand rolls over then tell
+	     * ntp_update_second() what we did in the last second so it can
+	     * calculate what to do in the next second.  It may also add
+	     * or subtract a leap second.
+	     */
+	    getnanotime(&nts);
+	    if (time_second != nts.tv_sec) {
+		leap = ntp_update_second(time_second, &nsec_adj);
+		basetime.tv_sec += leap;
+		time_second = nts.tv_sec + leap;
+		nsec_adj /= hz;
+	    }
+	}
+
+	/*
+	 * ITimer handling is per-tick, per-cpu.  I don't think psignal()
+	 * is mpsafe on curproc, so XXX get the mplock.
+	 */
+	if ((p = curproc) != NULL && try_mplock()) {
 		pstats = p->p_stats;
-		if (CLKF_USERMODE(frame) &&
+		if (frame && CLKF_USERMODE(frame) &&
 		    timevalisset(&pstats->p_timer[ITIMER_VIRTUAL].it_value) &&
 		    itimerdecr(&pstats->p_timer[ITIMER_VIRTUAL], tick) == 0)
 			psignal(p, SIGVTALRM);
 		if (timevalisset(&pstats->p_timer[ITIMER_PROF].it_value) &&
 		    itimerdecr(&pstats->p_timer[ITIMER_PROF], tick) == 0)
 			psignal(p, SIGPROF);
+		rel_mplock();
 	}
+}
 
-#if 0 /* SMP and BETTER_CLOCK */
-	forward_hardclock(pscnt);
+/*
+ * The statistics clock typically runs at a 125Hz rate, and is intended
+ * to be frequency offset from the hardclock (typ 100Hz).  It is per-cpu.
+ *
+ * NOTE! systimer! the MP lock might not be held here.  We can only safely
+ * manipulate objects owned by the current cpu.
+ *
+ * The stats clock is responsible for grabbing a profiling sample.
+ * Most of the statistics are only used by user-level statistics programs.
+ * The main exceptions are p->p_uticks, p->p_sticks, p->p_iticks, and
+ * p->p_estcpu.
+ *
+ * Like the other clocks, the stat clock is called from what is effectively
+ * a fast interrupt, so the context should be the thread/process that got
+ * interrupted.
+ */
+static void
+statclock(systimer_t info, struct intrframe *frame)
+{
+#ifdef GPROF
+	struct gmonparam *g;
+	int i;
 #endif
+	thread_t td;
+	struct proc *p;
+	int bump;
+	struct timeval tv;
+	struct timeval *stv;
 
 	/*
-	 * If no separate statistics clock is available, run it from here.
+	 * How big was our timeslice relative to the last time?
 	 */
-	if (stathz == 0)
-		statclock(frame);
+	microuptime(&tv);	/* mpsafe */
+	stv = &mycpu->gd_stattv;
+	if (stv->tv_sec == 0) {
+	    bump = 1;
+	} else {
+	    bump = tv.tv_usec - stv->tv_usec +
+		(tv.tv_sec - stv->tv_sec) * 1000000;
+	    if (bump < 0)
+		bump = 0;
+	    if (bump > 1000000)
+		bump = 1000000;
+	}
+	*stv = tv;
 
-	tco_forward(0);
-	ticks++;
+	td = curthread;
+	p = td->td_proc;
 
-#ifdef DEVICE_POLLING
-	hardclock_device_poll();	/* this is very short and quick */
-#endif /* DEVICE_POLLING */
+	if (frame && CLKF_USERMODE(frame)) {
+		/*
+		 * Came from userland, handle user time and deal with
+		 * possible process.
+		 */
+		if (p && (p->p_flag & P_PROFIL))
+			addupc_intr(p, CLKF_PC(frame), 1);
+		td->td_uticks += bump;
 
-	/*
-	 * Process callouts at a very low cpu priority, so we don't keep the
-	 * relatively high clock interrupt priority any longer than necessary.
-	 */
-	if (TAILQ_FIRST(&callwheel[ticks & callwheelmask]) != NULL) {
-		setsoftclock();
-	} else if (softticks + 1 == ticks) {
-		++softticks;
+		/*
+		 * Charge the time as appropriate
+		 */
+		if (p && p->p_nice > NZERO)
+			cp_time[CP_NICE] += bump;
+		else
+			cp_time[CP_USER] += bump;
+	} else {
+#ifdef GPROF
+		/*
+		 * Kernel statistics are just like addupc_intr, only easier.
+		 */
+		g = &_gmonparam;
+		if (g->state == GMON_PROF_ON && frame) {
+			i = CLKF_PC(frame) - g->lowpc;
+			if (i < g->textsize) {
+				i /= HISTFRACTION * sizeof(*g->kcount);
+				g->kcount[i]++;
+			}
+		}
+#endif
+		/*
+		 * Came from kernel mode, so we were:
+		 * - handling an interrupt,
+		 * - doing syscall or trap work on behalf of the current
+		 *   user process, or
+		 * - spinning in the idle loop.
+		 * Whichever it is, charge the time as appropriate.
+		 * Note that we charge interrupts to the current process,
+		 * regardless of whether they are ``for'' that process,
+		 * so that we know how much of its real time was spent
+		 * in ``non-process'' (i.e., interrupt) work.
+		 *
+		 * XXX assume system if frame is NULL.  A NULL frame 
+		 * can occur if ipi processing is done from an splx().
+		 */
+		if (frame && CLKF_INTR(frame))
+			td->td_iticks += bump;
+		else
+			td->td_sticks += bump;
+
+		if (frame && CLKF_INTR(frame)) {
+			cp_time[CP_INTR] += bump;
+		} else {
+			if (td == &mycpu->gd_idlethread)
+				cp_time[CP_IDLE] += bump;
+			else
+				cp_time[CP_SYS] += bump;
+		}
+	}
+}
+
+/*
+ * The scheduler clock typically runs at a 10Hz rate.  NOTE! systimer,
+ * the MP lock might not be held.  We can safely manipulate parts of curproc
+ * but that's about it.
+ */
+static void
+schedclock(systimer_t info, struct intrframe *frame)
+{
+	struct proc *p;
+	struct pstats *pstats;
+	struct rusage *ru;
+	struct vmspace *vm;
+	long rss;
+
+	schedulerclock(NULL);	/* mpsafe */
+	if ((p = curproc) != NULL) {
+		/* Update resource usage integrals and maximums. */
+		if ((pstats = p->p_stats) != NULL &&
+		    (ru = &pstats->p_ru) != NULL &&
+		    (vm = p->p_vmspace) != NULL) {
+			ru->ru_ixrss += pgtok(vm->vm_tsize);
+			ru->ru_idrss += pgtok(vm->vm_dsize);
+			ru->ru_isrss += pgtok(vm->vm_ssize);
+			rss = pgtok(vmspace_resident_count(vm));
+			if (ru->ru_maxrss < rss)
+				ru->ru_maxrss = rss;
+		}
 	}
 }
 
@@ -350,19 +544,18 @@
  * keeps the profile clock running constantly.
  */
 void
-startprofclock(p)
-	struct proc *p;
+startprofclock(struct proc *p)
 {
-	int s;
-
 	if ((p->p_flag & P_PROFIL) == 0) {
 		p->p_flag |= P_PROFIL;
+#if 0	/* XXX */
 		if (++profprocs == 1 && stathz != 0) {
 			s = splstatclock();
 			psdiv = psratio;
 			setstatclockrate(profhz);
 			splx(s);
 		}
+#endif
 	}
 }
 
@@ -370,169 +563,18 @@
  * Stop profiling on a process.
  */
 void
-stopprofclock(p)
-	struct proc *p;
+stopprofclock(struct proc *p)
 {
-	int s;
-
 	if (p->p_flag & P_PROFIL) {
 		p->p_flag &= ~P_PROFIL;
+#if 0	/* XXX */
 		if (--profprocs == 0 && stathz != 0) {
 			s = splstatclock();
 			psdiv = 1;
 			setstatclockrate(stathz);
 			splx(s);
 		}
-	}
-}
-
-/*
- * Statistics clock.  Grab profile sample, and if divider reaches 0,
- * do process and kernel statistics.  Most of the statistics are only
- * used by user-level statistics programs.  The main exceptions are
- * p->p_uticks, p->p_sticks, p->p_iticks, and p->p_estcpu.
- *
- * The statclock should be called from an exclusive, fast interrupt,
- * so the context should be the thread/process that got interrupted and
- * not an interrupt thread.
- */
-void
-statclock(frame)
-	struct clockframe *frame;
-{
-#ifdef GPROF
-	struct gmonparam *g;
-	int i;
-#endif
-	thread_t td;
-	struct pstats *pstats;
-	long rss;
-	struct rusage *ru;
-	struct vmspace *vm;
-	struct proc *p;
-	int bump;
-	struct timeval tv;
-	struct timeval *stv;
-
-	/*
-	 * How big was our timeslice relative to the last time
-	 */
-	microuptime(&tv);
-	stv = &mycpu->gd_stattv;
-	if (stv->tv_sec == 0) {
-	    bump = 1;
-	} else {
-	    bump = tv.tv_usec - stv->tv_usec +
-		(tv.tv_sec - stv->tv_sec) * 1000000;
-	    if (bump < 0)
-		bump = 0;
-	    if (bump > 1000000)
-		bump = 1000000;
-	}
-	*stv = tv;
-
-	td = curthread;
-	p = td->td_proc;
-
-	if (CLKF_USERMODE(frame)) {
-		/*
-		 * Came from userland, handle user time and deal with
-		 * possible process.
-		 */
-		if (p && (p->p_flag & P_PROFIL))
-			addupc_intr(p, CLKF_PC(frame), 1);
-#if 0	/* SMP and BETTER_CLOCK */
-		if (stathz != 0)
-			forward_statclock(pscnt);
-#endif
-		td->td_uticks += bump;
-
-		/*
-		 * Charge the time as appropriate
-		 */
-		if (p && p->p_nice > NZERO)
-			cp_time[CP_NICE] += bump;
-		else
-			cp_time[CP_USER] += bump;
-	} else {
-#ifdef GPROF
-		/*
-		 * Kernel statistics are just like addupc_intr, only easier.
-		 */
-		g = &_gmonparam;
-		if (g->state == GMON_PROF_ON) {
-			i = CLKF_PC(frame) - g->lowpc;
-			if (i < g->textsize) {
-				i /= HISTFRACTION * sizeof(*g->kcount);
-				g->kcount[i]++;
-			}
-		}
-#endif
-#if 0	/* SMP and BETTER_CLOCK */
-		if (stathz != 0)
-			forward_statclock(pscnt);
-#endif
-		/*
-		 * Came from kernel mode, so we were:
-		 * - handling an interrupt,
-		 * - doing syscall or trap work on behalf of the current
-		 *   user process, or
-		 * - spinning in the idle loop.
-		 * Whichever it is, charge the time as appropriate.
-		 * Note that we charge interrupts to the current process,
-		 * regardless of whether they are ``for'' that process,
-		 * so that we know how much of its real time was spent
-		 * in ``non-process'' (i.e., interrupt) work.
-		 */
-		if (CLKF_INTR(frame))
-			td->td_iticks += bump;
-		else
-			td->td_sticks += bump;
-
-		if (CLKF_INTR(frame)) {
-			cp_time[CP_INTR] += bump;
-		} else {
-			if (td == &mycpu->gd_idlethread)
-				cp_time[CP_IDLE] += bump;
-			else
-				cp_time[CP_SYS] += bump;
-		}
-	}
-
-	/*
-	 * bump psticks and check against gd_psticks.  When we hit the
-	 * 1*hz mark (psdiv ticks) we do the more expensive stuff.  If
-	 * psdiv changes we reset everything to avoid confusion.
-	 */
-	++psticks;
-	if (psticks < mycpu->gd_psticks && psdiv == mycpu->gd_psdiv)
-		return;
-
-	mycpu->gd_psdiv = psdiv;
-	mycpu->gd_psticks = psticks + psdiv;
-
-	/*
-	 * XXX YYY DragonFly... need to rewrite all of this,
-	 * only schedclock is distributed at the moment
-	 */
-	schedclock(NULL);
-#ifdef SMP
-	if (smp_started && invltlb_ok && !cold && !panicstr) /* YYY */
-		lwkt_send_ipiq_mask(mycpu->gd_other_cpus, schedclock, NULL);
 #endif
-
-	if (p != NULL) {
-		/* Update resource usage integrals and maximums. */
-		if ((pstats = p->p_stats) != NULL &&
-		    (ru = &pstats->p_ru) != NULL &&
-		    (vm = p->p_vmspace) != NULL) {
-			ru->ru_ixrss += pgtok(vm->vm_tsize);
-			ru->ru_idrss += pgtok(vm->vm_dsize);
-			ru->ru_isrss += pgtok(vm->vm_ssize);
-			rss = pgtok(vmspace_resident_count(vm));
-			if (ru->ru_maxrss < rss)
-				ru->ru_maxrss = rss;
-		}
 	}
 }
 
@@ -557,14 +599,6 @@
 SYSCTL_PROC(_kern, KERN_CLOCKRATE, clockrate, CTLTYPE_STRUCT|CTLFLAG_RD,
 	0, 0, sysctl_kern_clockrate, "S,clockinfo","");
 
-static __inline unsigned
-tco_delta(struct timecounter *tc)
-{
-
-	return ((tc->tc_get_timecount(tc) - tc->tc_offset_count) & 
-	    tc->tc_counter_mask);
-}
-
 /*
  * We have eight functions for looking at the clock, four for
  * microseconds and four for nanoseconds.  For each there is fast
